/* Problem URL: https://codeforces.com/contest/954/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vl fds(n);
    cin >> fds;

    if (n == 1) {
        cout << "YES\n";
        cout << "1 1000000000\n";
        return 0;
    }

    ll m = -1;

    nrep(i, 1, n) {
        if (fds[i] == fds[i - 1]) {
            cout << "NO\n";
            return 0;
        }

        if (abs(fds[i] - fds[i - 1]) == 1) {
            continue;
        }

        if (m == -1) {
            m = abs(fds[i] - fds[i - 1]);
            continue;
        }

        if (abs(fds[i] - fds[i - 1]) != m) {
             cout << "NO\n";
             return 0;
        }
    }

    if (m == -1) {
        cout << "YES\n";
        cout << "1 1000000000\n";
        return 0;
    }

    ll i = (fds[0] - 1) / m;
    ll j = (fds[0] - 1) % m;

    ll nans = i + 1;

    nrep(k, 1, n) {
        if (abs(fds[k] - fds[k - 1]) == 1) {
            ll jd = j + fds[k] - fds[k - 1];
            ll id = i;

            if (jd >= m || jd < 0) {
                cout << "NO\n";
                return 0;
            }

            i = id;
            j = jd;
            continue;
        }

        ll id = i + (fds[k] - fds[k - 1]) / m;
        ll jd = j;

        if (id < 0) {
            cout << "NO\n";
            return 0;
        }

        rmax(nans, id + 1);
        i = id;
        j = jd;
    }

    if (nans > 1e9 || m > 1e9) {
        cout << "NO\n";
        return 0;
    }

    cout << "YES\n";
    cout << nans << ' ' << m << '\n';
}
